// WARNING! All changes made in this file will be lost!
// Created from 'boxes.style' by 'codegen_style'
//
// This file is part of Desktop App Toolkit,
// a set of libraries for developing nice desktop applications.
//
// For license and copyright information please follow this link:
// https://github.com/desktop-app/legal/blob/master/LEGAL
//
#pragma once

#include "ui/style/style_core.h"

#include "styles/style_widgets.h"

namespace style {
namespace internal {

void init_style_boxes(int scale);

} // namespace internal

struct ScrollArea;
struct FlatLabel;
struct InputField;
struct TextStyle;
struct IconButton;
struct PeerListItem;
struct PeerList;
struct RoundButton;
struct LabelSimple;
struct MediaSlider;
struct LinkButton;
struct Checkbox;
struct Radio;
struct Toggle;
struct SettingsButton;
struct CrossButton;
struct RippleAnimation;
struct TextPalette;
struct InfiniteRadialAnimation;
struct ServiceCheck;
struct Box;
struct PopupMenu;

struct UserpicButton {
	style::size size;
	int photoSize;
	style::point photoPosition;
	style::RoundButton changeButton;
	style::icon changeIcon;
	style::point changeIconPosition;
	int duration;
	int uploadHeight;
	style::color uploadBg;
	style::icon uploadIcon;
	style::point uploadIconPosition;
};

struct UserpicsRow {
	style::UserpicButton button;
	style::color bg;
	int shift;
	int stroke;
	bool complex;
	bool invert;
};

struct ShortInfoBox {
	style::FlatLabel label;
	style::FlatLabel labeled;
	style::FlatLabel labeledOneLine;
};

struct CalendarSizes {
	int width;
	int daysHeight;
	style::size cellSize;
	int cellInner;
	style::margins padding;
};

struct CalendarColors {
	style::color dayTextColor;
	style::color dayTextGrayedOutColor;
	style::IconButton iconButtonNext;
	style::icon iconButtonNextDisabled;
	style::IconButton iconButtonPrevious;
	style::icon iconButtonPreviousDisabled;
	style::color iconButtonRippleColorDisabled;
	style::color rippleColor;
	style::color rippleColorHighlighted;
	style::color rippleGrayedOutColor;
	style::color titleTextColor;
};

} // namespace style

namespace st {
extern const int &countryRowHeight;
extern const style::font &countryRowNameFont;
extern const style::color &countryRowNameFg;
extern const style::margins &countryRowPadding;
extern const style::font &countryRowCodeFont;
extern const style::color &countryRowBg;
extern const style::color &countryRowBgOver;
extern const style::color &countryRowCodeFg;
extern const style::color &countryRowCodeFgOver;
extern const int &countriesSkip;
extern const style::ScrollArea &countriesScroll;
extern const style::point &boxPhotoTitlePosition;
extern const style::margins &boxPhotoPadding;
extern const int &boxPhotoCompressedSkip;
extern const int &boxPhotoCaptionSkip;
extern const style::icon &defaultChangeUserpicIcon;
extern const style::icon &defaultUploadUserpicIcon;
extern const style::UserpicButton &defaultUserpicButton;
extern const int &uploadUserpicSize;
extern const style::UserpicButton &uploadUserpicButton;
extern const int &uploadUserpicButtonBorder;
extern const style::UserpicButton &restoreUserpicIcon;
extern const style::FlatLabel &confirmInviteTitle;
extern const style::FlatLabel &confirmInviteAbout;
extern const style::FlatLabel &confirmInviteStatus;
extern const style::margins &confirmInviteAboutPadding;
extern const style::margins &confirmInviteAboutRequestsPadding;
extern const int &confirmInviteTitleTop;
extern const int &confirmInvitePhotoSize;
extern const int &confirmInvitePhotoTop;
extern const int &confirmInviteStatusTop;
extern const int &confirmInviteUserHeight;
extern const int &confirmInviteUserPhotoSize;
extern const int &confirmInviteUserPhotoTop;
extern const int &confirmInviteUsersWidth;
extern const style::FlatLabel &confirmInviteUserName;
extern const int &confirmInviteUserNameTop;
extern const style::FlatLabel &confirmPhoneAboutLabel;
extern const style::InputField &confirmPhoneCodeField;
extern const style::FlatLabel &aboutRevokePublicLabel;
extern const style::icon &contactUserIcon;
extern const style::icon &contactPhoneIcon;
extern const style::point &contactIconPosition;
extern const style::margins &contactPadding;
extern const int &contactSkip;
extern const int &contactPhoneSkip;
extern const int &contactsPhotoSize;
extern const style::margins &contactsPadding;
extern const int &contactsNameTop;
extern const style::TextStyle &contactsNameStyle;
extern const int &contactsStatusTop;
extern const style::font &contactsStatusFont;
extern const style::point &contactsCheckPosition;
extern const style::IconButton &contactsSortButton;
extern const style::icon &contactsSortOnlineIcon;
extern const style::icon &contactsSortOnlineIconOver;
extern const int &membersMarginTop;
extern const int &membersMarginBottom;
extern const style::PeerListItem &peerListBoxItem;
extern const style::PeerList &peerListBox;
extern const int &localStorageRowHeight;
extern const style::margins &localStorageRowPadding;
extern const style::FlatLabel &localStorageRowTitle;
extern const style::FlatLabel &localStorageRowSize;
extern const style::RoundButton &localStorageClear;
extern const style::LabelSimple &localStorageLimitLabel;
extern const style::margins &localStorageLimitLabelMargin;
extern const style::MediaSlider &localStorageLimitSlider;
extern const style::margins &localStorageLimitMargin;
extern const int &shareRowsTop;
extern const int &shareRowHeight;
extern const int &sharePhotoTop;
extern const style::PeerListItem &shareBoxListItem;
extern const style::PeerList &shareBoxList;
extern const int &shareNameTop;
extern const int &shareColumnSkip;
constexpr int shareActivateDuration = 150;
constexpr int shareScrollDuration = 300;
extern const style::InputField &shareComment;
extern const style::margins &shareCommentPadding;
extern const style::icon &notificationsBoxMonitor;
extern const int &notificationsBoxScreenTop;
extern const style::size &notificationsBoxScreenSize;
extern const int &notificationsSampleSkip;
extern const int &notificationsSampleTopSkip;
extern const int &notificationsSampleBottomSkip;
extern const int &notificationsSampleMargin;
constexpr double notificationSampleOpacity = 0.5;
extern const style::size &notificationSampleSize;
extern const style::margins &membersAboutLimitPadding;
extern const style::FlatLabel &membersAbout;
extern const style::RoundButton &fragmentBoxButton;
extern const style::font &passcodeHeaderFont;
extern const int &passcodeHeaderHeight;
extern const style::InputField &passcodeInput;
extern const style::RoundButton &passcodeSubmit;
extern const int &passcodeSubmitSkip;
extern const style::margins &passcodePadding;
extern const int &passcodeTextLine;
extern const int &passcodeLittleSkip;
extern const int &passcodeAboutSkip;
extern const int &passcodeSkip;
extern const style::IconButton &passcodeSystemUnlock;
extern const style::icon &passcodeSystemTouchID;
extern const style::icon &passcodeSystemAppleWatch;
extern const style::icon &passcodeSystemSystemPwd;
extern const style::FlatLabel &passcodeSystemUnlockLater;
extern const int &passcodeSystemUnlockSkip;
extern const style::color &newGroupAboutFg;
extern const style::margins &newGroupPadding;
extern const int &newGroupSkip;
extern const style::margins &newGroupInfoPadding;
extern const style::margins &newGroupLinkPadding;
extern const int &newGroupLinkTop;
extern const style::font &newGroupLinkFont;
extern const style::point &newGroupNamePosition;
extern const style::margins &newGroupDescriptionPadding;
extern const style::InputField &newGroupDescription;
extern const style::InputField &setupChannelLink;
extern const int &themeWarningWidth;
extern const int &themeWarningHeight;
extern const int &themeWarningTextTop;
extern const int &aboutWidth;
extern const int &aboutVersionTop;
extern const style::LinkButton &aboutVersionLink;
extern const int &aboutTextTop;
extern const int &aboutSkip;
extern const style::FlatLabel &aboutLabel;
extern const style::font &autoDownloadTitleFont;
extern const style::MediaSlider &autoDownloadLimitSlider;
extern const style::margins &autoDownloadLimitPadding;
extern const int &confirmMaxHeight;
extern const style::InputField &supportInfoField;
extern const style::InputField &connectionHostInputField;
extern const style::InputField &connectionPortInputField;
extern const style::InputField &connectionUserInputField;
extern const style::InputField &connectionPasswordInputField;
extern const int &connectionIPv6Skip;
extern const int &autolockWidth;
extern const style::Checkbox &autolockButton;
extern const style::Radio &langsRadio;
extern const int &backgroundPadding;
extern const style::size &backgroundSize;
extern const style::ScrollArea &backgroundScroll;
extern const int &sendMediaPreviewSize;
constexpr int sendMediaPreviewHeightMax = 1280;
extern const int &sendMediaRowSkip;
extern const style::FlatLabel &editMediaHintLabel;
extern const int &calendarTitleHeight;
extern const style::IconButton &calendarPrevious;
extern const style::icon &calendarPreviousDisabled;
extern const style::IconButton &calendarNext;
extern const style::icon &calendarNextDisabled;
extern const style::font &calendarTitleFont;
extern const style::CalendarSizes &defaultCalendarSizes;
extern const style::font &calendarDaysFont;
extern const style::color &calendarDaysFg;
extern const style::ScrollArea &calendarScroll;
extern const style::CalendarColors &defaultCalendarColors;
extern const style::TextStyle &passcodeTextStyle;
extern const style::margins &usernamePadding;
extern const int &usernameSkip;
extern const style::color &usernameDefaultFg;
extern const style::margins &editMediaLabelMargins;
extern const style::margins &editMediaCheckboxMargins;
extern const int &downloadPathSkip;
extern const int &colorEditWidth;
extern const int &colorEditSkip;
extern const int &colorPickerSize;
extern const int &colorPickerMarkRadius;
extern const int &colorPickerMarkLine;
extern const int &colorSliderSkip;
extern const style::icon &colorSliderArrowLeft;
extern const style::icon &colorSliderArrowRight;
extern const style::icon &colorSliderArrowTop;
extern const style::icon &colorSliderArrowBottom;
extern const int &colorSliderWidth;
extern const style::size &colorSampleSize;
extern const int &colorFieldSkip;
extern const style::InputField &colorValueInput;
extern const style::InputField &colorResultInput;
extern const style::RoundButton &changePhoneButton;
extern const style::margins &changePhoneButtonPadding;
extern const style::FlatLabel &changePhoneTitle;
extern const style::margins &changePhoneTitlePadding;
extern const style::FlatLabel &changePhoneDescription;
extern const style::margins &changePhoneDescriptionPadding;
extern const style::margins &changePhoneIconPadding;
extern const int &changePhoneIconSize;
extern const style::FlatLabel &changePhoneLabel;
extern const style::FlatLabel &changePhoneError;
extern const int &adminLogFilterUserpicLeft;
extern const int &adminLogFilterLittleSkip;
extern const style::Checkbox &adminLogFilterCheckbox;
extern const int &adminLogFilterSkip;
extern const style::Checkbox &adminLogFilterUserCheckbox;
extern const style::Checkbox &rightsCheckbox;
extern const style::Toggle &rightsToggle;
extern const style::SettingsButton &rightsButton;
extern const int &rightsButtonToggleWidth;
extern const style::margins &rightsDividerMargin;
extern const style::margins &rightsHeaderMargin;
extern const style::margins &rightsToggleMargin;
extern const style::margins &rightsAboutMargin;
extern const style::UserpicButton &rightsPhotoButton;
extern const style::margins &rightsPhotoMargin;
extern const style::TextStyle &rightsNameStyle;
extern const int &rightsNameTop;
extern const int &rightsStatusTop;
extern const style::FlatLabel &rightsHeaderLabel;
extern const style::CrossButton &groupStickersRemove;
extern const style::point &groupStickersRemovePosition;
extern const style::margins &groupStickersFieldPadding;
extern const style::InputField &groupStickersField;
extern const int &groupStickersSubTitleHeight;
extern const style::margins &proxyUsePadding;
extern const style::margins &proxyTryIPv6Padding;
extern const style::margins &proxyRowPadding;
extern const int &proxyRowIconSkip;
extern const int &proxyRowSkip;
extern const style::RippleAnimation &proxyRowRipple;
extern const style::color &proxyRowTitleFg;
extern const style::TextPalette &proxyRowTitlePalette;
extern const style::TextStyle &proxyRowTitleStyle;
extern const style::color &proxyRowStatusFg;
extern const style::color &proxyRowStatusFgOnline;
extern const style::color &proxyRowStatusFgOffline;
extern const style::color &proxyRowStatusFgAvailable;
extern const style::FlatLabel &proxyEditTitle;
extern const style::margins &proxyEditTitlePadding;
extern const style::margins &proxyEditTypePadding;
extern const style::margins &proxyEditInputPadding;
extern const int &proxyEditSkip;
extern const style::FlatLabel &proxyEmptyListLabel;
extern const style::margins &proxyEmptyListPadding;
extern const style::point &proxyCheckingPosition;
extern const int &proxyCheckingSkip;
extern const style::InfiniteRadialAnimation &proxyCheckingAnimation;
extern const style::point &proxyDropdownDownPosition;
extern const style::point &proxyDropdownUpPosition;
extern const style::margins &proxyAboutPadding;
extern const style::margins &proxyAboutSponsorPadding;
extern const style::FlatLabel &proxyApplyBoxLabel;
extern const style::margins &markdownLinkFieldPadding;
extern const style::FlatLabel &termsContent;
extern const style::margins &termsPadding;
extern const style::margins &termsAgePadding;
extern const int &themesSmallSkip;
extern const style::IconButton &themesMenuToggle;
extern const style::point &themesMenuPosition;
extern const style::InputField &createPollField;
extern const style::margins &createPollFieldPadding;
extern const style::InputField &createPollOptionField;
extern const style::InputField &createPollOptionFieldPremium;
extern const style::point &createPollOptionFieldPremiumEmojiPosition;
extern const style::InputField &createPollSolutionField;
extern const style::margins &createPollLimitPadding;
extern const style::CrossButton &createPollOptionRemove;
extern const style::point &createPollOptionRemovePosition;
extern const int &createPollOptionEmojiPositionSkip;
extern const style::FlatLabel &createPollWarning;
extern const style::point &createPollWarningPosition;
extern const style::margins &createPollCheckboxMargin;
extern const style::margins &createPollFieldTitlePadding;
extern const style::point &sendGifWithCaptionEmojiPosition;
extern const style::Checkbox &backgroundCheckbox;
extern const style::ServiceCheck &backgroundCheck;
extern const style::margins &backgroundConfirmPadding;
extern const style::RoundButton &backgroundConfirm;
extern const style::RoundButton &backgroundConfirmCancel;
extern const style::Checkbox &urlAuthCheckbox;
extern const style::margins &addContactFieldMargin;
extern const style::margins &addContactWarningMargin;
extern const style::FlatLabel &blockUserConfirmation;
extern const int &transferCheckWidth;
extern const style::margins &slowmodeLabelsMargin;
extern const style::LabelSimple &slowmodeLabel;
extern const style::FlatLabel &boostsUnrestrictLabel;
extern const style::InputField &customBadgeField;
extern const style::FlatLabel &pollResultsQuestion;
extern const style::FlatLabel &pollResultsVotesCount;
extern const style::margins &pollResultsHeaderPadding;
extern const style::SettingsButton &pollResultsShowMore;
extern const style::SettingsButton &inviteViaLinkButton;
extern const style::icon &inviteViaLinkIcon;
extern const style::point &inviteViaLinkIconPosition;
extern const style::PeerList &peerListWithInviteViaLink;
extern const style::PeerList &peerListSingleRow;
extern const style::PeerList &peerListSmallSkips;
extern const int &scheduleHeight;
extern const int &scheduleDateTop;
extern const style::InputField &scheduleDateField;
extern const style::InputField &scheduleTimeField;
extern const int &scheduleDateWidth;
extern const int &scheduleTimeWidth;
extern const int &scheduleAtSkip;
extern const int &scheduleAtTop;
extern const style::FlatLabel &scheduleAtLabel;
extern const style::FlatLabel &scheduleTimeSeparator;
extern const style::margins &scheduleTimeSeparatorPadding;
extern const style::InputField &muteBoxTimeField;
extern const style::margins &muteBoxTimeFieldPadding;
extern const style::FlatLabel &boxAttentionDividerLabel;
extern const style::InputField &autolockDateField;
extern const style::InputField &autolockTimeField;
extern const int &autolockTimeWidth;
extern const int &sponsoredUrlButtonSkip;
extern const style::RoundButton &sponsoredUrlButton;
extern const style::FlatLabel &requestPeerRestriction;
extern const style::PeerListItem &requestsBoxItem;
extern const style::PeerList &requestsBoxList;
extern const style::PeerList &contactsWithStories;
extern const int &storiesReadLineTwice;
extern const int &storiesUnreadLineTwice;
extern const style::RoundButton &requestsAcceptButton;
extern const style::RoundButton &requestsRejectButton;
extern const style::point &requestAcceptPosition;
extern const int &requestButtonsSkip;
extern const style::SettingsButton &ringtonesBoxButton;
extern const int &ringtonesBoxSkip;
constexpr int gradientButtonGlareDuration = 700;
constexpr int gradientButtonGlareTimeout = 2000;
extern const int &gradientButtonGlareWidth;
extern const style::FlatLabel &infoLabeledOneLine;
extern const int &infoLabelSkip;
extern const style::FlatLabel &infoLabeled;
extern const style::FlatLabel &infoLabel;
extern const style::ShortInfoBox &shortInfoBox;
extern const style::FlatLabel &birthdayLabeled;
extern const style::FlatLabel &birthdayLabel;
extern const style::icon &birthdayTodayIcon;
extern const style::margins &inviteForbiddenUserpicsPadding;
extern const style::FlatLabel &inviteForbiddenInfo;
extern const style::margins &inviteForbiddenInfoPadding;
extern const style::margins &inviteForbiddenSubscribePadding;
extern const style::margins &inviteForbiddenOrLabelPadding;
extern const style::FlatLabel &inviteForbiddenTitle;
extern const style::margins &inviteForbiddenTitlePadding;
extern const style::color &inviteForbiddenLockBg;
extern const style::icon &inviteForbiddenLockIcon;
extern const int &collectibleIconDiameter;
extern const int &collectibleIcon;
extern const style::margins &collectibleIconPadding;
extern const style::FlatLabel &collectibleHeader;
extern const style::margins &collectibleHeaderPadding;
extern const style::margins &collectibleOwnerPadding;
extern const style::FlatLabel &collectibleInfo;
extern const style::margins &collectibleInfoPadding;
extern const style::margins &collectibleInfoTonMargins;
extern const style::RoundButton &collectibleMore;
extern const style::margins &collectibleMorePadding;
extern const style::RoundButton &collectibleCopy;
extern const style::Box &collectibleBox;
extern const style::UserpicButton &moderateBoxUserpic;
extern const style::icon &moderateBoxExpand;
extern const int &moderateBoxExpandHeight;
extern const int &moderateBoxExpandRight;
extern const int &moderateBoxExpandInnerSkip;
extern const style::font &moderateBoxExpandFont;
extern const int &moderateBoxExpandToggleSize;
extern const int &moderateBoxExpandToggleFourStrokes;
extern const style::icon &moderateBoxExpandIcon;
extern const style::icon &moderateBoxExpandIconDown;
extern const style::FlatLabel &moderateBoxDividerLabel;
extern const style::font &profileQrFont;
extern const int &profileQrCenterSize;
extern const int &profileQrBackgroundRadius;
extern const style::icon &profileQrIcon;
extern const style::margins &profileQrBackgroundMargins;
extern const style::margins &profileQrBackgroundPadding;
extern const style::PopupMenu &foldersMenu;
extern const style::UserpicButton &fakeUserpicButton;
} // namespace st
